<?php
namespace Opencart\Admin\Controller\Extension\Allinoneaccessibility\Module;

class Allinoneaccessibility extends \Opencart\System\Engine\Controller {
    private $error = array();
    public function install(): void {
		$file = DIR_OPENCART . 'extension/allinoneaccessibility/system/config/allinoneaccessibility/allinoneaccessibility.php';

		if (file_exists($file)) {
			$_ = array();
			require($file);
            $this->load->model('setting/setting');
   			$this->model_setting_setting->editSetting('module_allinoneaccessibility', $_);
		}
        $this->load->model('setting/event');
        $event = [
            'code' => 'allin1accessibility_front',
            'trigger' => 'catalog/view/common/header/before',
            'action' => 'extension/allinoneaccessibility/module/allinoneaccessibility.commoncontroller',
            'description' => 'All in one accessibility Front',
            'sort_order' => 1,
            'status' => true
           ];
        // Front  events 
		$this->model_setting_event->deleteEventByCode('allin1accessibility_front');
		$this->model_setting_event->addEvent($event);
    }
    
    
    public function index(): void {
        $this->load->language('extension/allinoneaccessibility/module/allinoneaccessibility');
        $this->document->setTitle($this->language->get('heading_title'));
        
        $this->load->model('setting/setting');
        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
            
            /* Start Code Check Key Valid OR Not */
            $url = "https://www.skynettechnologies.com/add-ons/license-api.php?";
            $postdata['token'] = $this->request->post["allinoneaccessibility_licenseKey"];
            $postdata['SERVER_NAME'] = $_SERVER['SERVER_NAME'];

            $curl = curl_init($url);
            curl_setopt($curl, CURLOPT_URL, $url);
            curl_setopt($curl, CURLOPT_POSTFIELDS, $postdata);
            curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($curl, CURLOPT_SSL_VERIFYHOST, false);
            curl_setopt($curl, CURLOPT_SSL_VERIFYPEER, false);
            $resp = curl_exec($curl);
            $resp = json_decode($resp);

            if (empty($resp->accessibilityloader) ){
                $is_valid = 0;
            }else{
                $is_valid = 1;
            }
            /* End Code Check Key Valid OR Not */

            $dataToSave = [
                "module_allinoneaccessibility_licenseKey" =>  $this->request->post["allinoneaccessibility_licenseKey"],
                "module_allinoneaccessibility_colorCode"  =>  $this->request->post["allinoneaccessibility_colorCode"],
                "module_allinoneaccessibility_Position"   =>  $this->request->post["allinoneaccessibility_Position"],
                "module_allinoneaccessibility_icon_type"   =>  $this->request->post["allinoneaccessibility_icon_type"],
                "module_allinoneaccessibility_icon_size"   =>  $this->request->post["allinoneaccessibility_icon_size"],
                'module_allinoneaccessibility_status' => 1,
                'module_allinoneaccessibility_valid_key' =>$is_valid
            ];
			$this->model_setting_setting->editSetting('module_allinoneaccessibility',$dataToSave);

			$this->session->data['success'] = $this->language->get('text_success');
            // Start Code For Save Data on server By API //
            
            $url = "https://ada.skynettechnologies.us/api/widget-setting-update-platform";
            $data = [
                'u'                 => $_SERVER['SERVER_NAME'],
                'widget_position'   => ($this->request->post["allinoneaccessibility_Position"] != '') ? $this->request->post["allinoneaccessibility_Position"] : "",
                'widget_color_code' => ($this->request->post["allinoneaccessibility_colorCode"] != '') ? $this->request->post["allinoneaccessibility_colorCode"] : "",
                'widget_icon_size'  => ($this->request->post["allinoneaccessibility_icon_size"] != '') ? $this->request->post["allinoneaccessibility_icon_size"] : "",
                'widget_icon_type'  => ($this->request->post["allinoneaccessibility_icon_type"] != '') ? $this->request->post["allinoneaccessibility_icon_type"] : ""

            ];
           
            
            $cl = curl_init($url);
            curl_setopt($cl, CURLOPT_URL, $url);
            curl_setopt($cl, CURLOPT_POST, true);
            curl_setopt($cl, CURLOPT_RETURNTRANSFER, true);
            curl_setopt($cl, CURLOPT_POSTFIELDS, $data);

            $respdata = curl_exec($cl);
            curl_close($cl);
            
            // End Code For Save Data on server By API //
			$this->response->redirect($this->url->link('extension/allinoneaccessibility/module/allinoneaccessibility', 'user_token=' . $this->session->data['user_token'] . '&type=module', true));
		}
        /* Get Banner coupon HtML*/
            $c = curl_init();

            curl_setopt_array($c, array(
            CURLOPT_URL => 'https://www.skynettechnologies.com/add-ons/discount_offer.php?platform=opencart',
            CURLOPT_RETURNTRANSFER => true,
            CURLOPT_ENCODING => '',
            CURLOPT_MAXREDIRS => 10,
            CURLOPT_TIMEOUT => 0,
            CURLOPT_FOLLOWLOCATION => true,
            CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
            CURLOPT_CUSTOMREQUEST => 'GET',
            ));
            
            $response = curl_exec($c);
            
            curl_close($c);
        /* Get Banner coupon HtML*/
        
        
        $data['breadcrumbs'] = array();

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_home'),
			'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('text_extension'),
			'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true)
		);

		$data['breadcrumbs'][] = array(
			'text' => $this->language->get('heading_title'),
			'href' => $this->url->link('extension/allinoneaccessibility/module/allinoneaccessibility', 'user_token=' . $this->session->data['user_token'], true)
		);

        if (isset($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        } else {
            $data['error_warning'] = '';
        }

        if (isset($this->error['allinoneaccessibility_licenseKey'])) {
            $data['error_licensekey'] = $this->error['allinoneaccessibility_licenseKey'];
        } else {
            $data['error_licensekey'] = '';
        }

        if (isset($this->error['allinoneaccessibility_colorCode'])) {
            $data['error_colorcode'] = $this->error['allinoneaccessibility_colorCode'];
        } else {
            $data['error_colorcode'] = '';
        }

        if (isset($this->session->data['success'])) {
			$data['success'] = $this->session->data['success'];

			unset($this->session->data['success']);
		} else {
			$data['success'] = '';
		}

        $data['action'] = $this->url->link('extension/allinoneaccessibility/module/allinoneaccessibility', 'user_token=' . $this->session->data['user_token'], true);

		$data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=module', true);
        
        $this->load->model('setting/store');
		$data['stores'] = $this->model_setting_store->getStores();

        $data['user_token'] = $this->session->data['user_token'];


        if ($this->request->server['REQUEST_METHOD'] != 'POST') {
			$module_info = $this->model_setting_setting->getSetting('module_allinoneaccessibility');
        }

        if (isset($this->request->post['allinoneaccessibility_licenseKey'])) {
            $data['allinoneaccessibility_licenseKey'] = $this->request->post['allinoneaccessibility_licenseKey'];
        } else {
            $data['allinoneaccessibility_licenseKey'] =$module_info['module_allinoneaccessibility_licenseKey'];
        }

        if (isset($this->request->post['allinoneaccessibility_colorCode'])) {
            $data['allinoneaccessibility_colorCode'] = $this->request->post['allinoneaccessibility_colorCode'];
        } else {
            $data['allinoneaccessibility_colorCode'] =$module_info['module_allinoneaccessibility_colorCode'];
        }

        if (isset($this->request->post['allinoneaccessibility_Position'])) {
            $data['allinoneaccessibility_Position'] = $this->request->post['allinoneaccessibility_Position'];
        } else {
            $data['allinoneaccessibility_Position'] =$module_info['module_allinoneaccessibility_Position'];
        }

        if (isset($this->request->post['allinoneaccessibility_icon_type'])) {
            $data['allinoneaccessibility_icon_type'] = $this->request->post['allinoneaccessibility_icon_type'];
        } else {
            $data['allinoneaccessibility_icon_type'] =$module_info['module_allinoneaccessibility_icon_type'];
        }

        if (isset($this->request->post['allinoneaccessibility_icon_size'])) {
            $data['allinoneaccessibility_icon_size'] = $this->request->post['allinoneaccessibility_icon_size'];
        } else {
            $data['allinoneaccessibility_icon_size'] =$module_info['module_allinoneaccessibility_icon_size'];
        }

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');
        $data['domain'] = $_SERVER['SERVER_NAME'];
        $data['is_valid_key'] = $module_info['module_allinoneaccessibility_valid_key'];
        $data['coupon_html'] = $response;
        $this->response->setOutput($this->load->view('extension/allinoneaccessibility/module/allinoneaccessibility', $data));
    }
    

    public function uninstall() : void{
        $this->load->model('setting/event');
        $this->model_setting_event->deleteEventByCode('allin1accessibility_front');
    }
    protected function validate() {
        if (!$this->user->hasPermission('modify', 'extension/allinoneaccessibility/module/allinoneaccessibility')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }

        return !$this->error;
    }
}
